#version 450 core
#extension GL_ARB_shader_storage_buffer_object : require

in int gl_VertexID;

struct vertBlock
{
	int exists;
	float pos0;
	float pos1;
	float pos2;
	int texi;
};

// Input vertex data, different for all executions of this shader.
layout(std430, binding=2) buffer vb {
        vertBlock verts[];
};
layout(std430, binding=1) buffer ti {
        int indexes[];
};

out vec2 UVs[3];
out vec3 alphas;

// Values that stay constant for the whole mesh.
uniform mat4 MVP;
uniform vec2 UVexamp[3];

void main(){
	// Output position of the vertex, in clip space : MVP * position
	gl_Position =  MVP * vec4(verts[indexes[gl_VertexID]].pos0, verts[indexes[gl_VertexID]].pos1, verts[indexes[gl_VertexID]].pos2, 1);
	gl_Position.xy = gl_Position.xy / gl_Position.w;
	gl_Position.w = 1;
//	gl_Position = vec4(vertexPosition,1);

	int div = gl_VertexID / 3;
	int id = gl_VertexID - (div * 3);
	
	int texs[3];
	if(id == 0) {
		texs[0] = verts[indexes[gl_VertexID]].texi;
		texs[1] = verts[indexes[gl_VertexID + 1]].texi;
		texs[2] = verts[indexes[gl_VertexID + 2]].texi;
	} else if(id == 1) {
		texs[0] = verts[indexes[gl_VertexID - 1]].texi;
		texs[1] = verts[indexes[gl_VertexID]].texi;
		texs[2] = verts[indexes[gl_VertexID + 1]].texi;
	} else if(id == 2) {
		texs[0] = verts[indexes[gl_VertexID - 2]].texi;
		texs[1] = verts[indexes[gl_VertexID - 1]].texi;
		texs[2] = verts[indexes[gl_VertexID]].texi;
	}
	
	int i;
	for(i = 0; i < 3; i++) {
		UVs[i] = UVexamp[id];
		if(texs[i] == 1) {
			UVs[i][0] += .33;
		} else if(texs[i] == 2) {
			UVs[i][0] += .66;
		} else if(texs[i] == 3) {
			UVs[i][1] -= .33;
		} else if(texs[i] == 4) {
			UVs[i][0] += .33;
			UVs[i][1] -= .33;
		} else if(texs[i] == 5) {
			UVs[i][0] += .66;
			UVs[i][1] -= .33;
		}
		//if(texs[i] == 1) {
		//	UVs[i][0] += .5;
		//} else if(texs[i] == 2) {
		//	UVs[i][1] -= .5;
		//} else if(texs[i] == 3) {
		//	UVs[i][0] += .5;
		//	UVs[i][1] -= .5;
		//}
	}
	
	alphas[0] = 0;
	alphas[1] = 0;
	alphas[2] = 0;
	alphas[id] = 1;
}

