#version 330 core

// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 vertexUV;

// Output data ; will be interpolated for each fragment.
out vec2 UV;

// Values that stay constant for the whole mesh.
uniform mat4 MVP;

uniform mat4 Bone[10];

void main(){
	// Output position of the vertex, in clip space : MVP * position
	gl_Position =  MVP * vec4(vertexPosition_modelspace,1);
	gl_Position.xy = gl_Position.xy / gl_Position.w;
	gl_Position.w = 1;

    // UV of the vertex. No special space for this one.
	UV = vertexUV;

	// Flips the y of the UV coord.
	// UV = vec2(vertexUV.x, 1.0-vertexUV.y);
}

